Problem description:

Given an array of points where points[i] = [xi, yi] represents a point on the X-Y plane and an integer k, return the k closest points to the origin (0, 0).

The distance between two points on the X-Y plane is the Euclidean distance (i.e., $√(x1 - x2)^2 + (y1 - y2)^2$).

You may return the answer in any order. The answer is guaranteed to be unique (except for the order that it is in).

Example 1:

1
2
3
4
5
6
7
Input: points = [[1,3],[-2,2]], k = 1
Output: [[-2,2]]
Explanation:
The distance between (1, 3) and the origin is sqrt(10).
The distance between (-2, 2) and the origin is sqrt(8).
Since sqrt(8) < sqrt(10), (-2, 2) is closer to the origin.
We only want the closest k = 1 points from the origin, so the answer is just [[-2,2]].

Example 2:

1
2
3
Input: points = [[3,3],[5,-1],[-2,4]], k = 2
Output: [[3,3],[-2,4]]
Explanation: The answer [[-2,4],[3,3]] would also be accepted.

Solution:

Use a heap to solve it.

1
2
3
4
5
6
7
8
9
10
11
12
13
14
class Solution:
def kClosest(self, points: List[List[int]], k: int) -> List[List[int]]:
hq = []
for point in points:
dis = point[0] **2 + point[1]**2
if len(hq) < k:
# Since python is min-heap, pop() would return the smallest element
# if pointA distance to origin is 10, pointB distance to origin is 8
# -10 would be pop out
heapq.heappush(hq, (-dis, point))
else:
heapq.heappushpop(hq, (-dis, point))

return [point for (dist, point) in hq]

time complexity: $O(nlogk)$, only k element in heap, push n times
space complexity: $O(n)$, heap size
reference:
related problem: